## virtualbox-ose 1.5.0

=== src/VBox/HostDrivers/Support/linux/Makefile ===
#
# Makefile for the VirtualBox Linux Host Driver.
# (For 2.6.x this file must be called 'Makefile'!)
#

#
#
#  Copyright (C) 2006 innotek GmbH
#
#  This file is part of VirtualBox Open Source Edition (OSE), as
#  available from http://www.virtualbox.org. This file is free software;
#  you can redistribute it and/or modify it under the terms of the GNU
#  General Public License as published by the Free Software Foundation,
#  in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
#  distribution. VirtualBox OSE is distributed in the hope that it will
#  be useful, but WITHOUT ANY WARRANTY of any kind.

#
# First, figure out which architecture we're targeting.
# (We have to support basic cross building (ARCH=i386|x86_64).)
#
ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
 $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
 BUILD_TARGET_ARCH :=
endif
ifeq ($(BUILD_TARGET_ARCH),)
 ifeq ($(ARCH),x86_64)
  BUILD_TARGET_ARCH := amd64
 else
  ifeq ($(ARCH),i386)
   BUILD_TARGET_ARCH := x86
  else
   ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
    BUILD_TARGET_ARCH := amd64
   else
    BUILD_TARGET_ARCH := x86
   endif
  endif
 endif
endif


MODULE = vboxdrv
OBJS   = \
	linux/SUPDrv-linux.o \
	SUPDRVShared.o \
	r0drv/alloc-r0drv.o \
	r0drv/initterm-r0drv.o \
	r0drv/linux/alloc-r0drv-linux.o \
	r0drv/linux/initterm-r0drv-linux.o \
	r0drv/linux/process-r0drv-linux.o \
	r0drv/linux/semaphore-r0drv-linux.o \
	r0drv/linux/spinlock-r0drv-linux.o \
	r0drv/linux/thread-r0drv-linux.o
ifeq ($(BUILD_TARGET_ARCH),amd64)
OBJS  += alloc/heapsimple.o
endif

ifneq ($(MAKECMDGOALS),clean)

# kernel base directory
ifndef KERN_DIR
 KERN_DIR := /lib/modules/$(shell uname -r)/build
 ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
  KERN_DIR := /usr/src/linux
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   $(error Error: unable to find the sources of your current Linux kernel. Specify KERN_DIR=<directory> and run Make again.)
  endif
  $(warning Warning: using /usr/src/linux as the source directory of your Linux kernel. If this is not correct, specify KERN_DIR=<directory> and run Make again.)
 endif
else
 ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
  $(error Error: KERN_DIR does not point to a directory.)
 endif
endif

# includes
ifndef KERN_INCL
 KERN_INCL = $(KERN_DIR)/include
endif
ifneq ($(shell if test -d $(KERN_INCL); then echo yes; fi),yes)
 $(error Error: unable to find the include directory for your current Linux kernel. Specify KERN_INCL=<directory> and run Make again.)
endif

# module install dir.
ifneq ($(filter install install_rpm,$(MAKECMDGOALS)),)
 ifndef MODULE_DIR
  MODULE_DIR_TST := /lib/modules/$(shell uname -r)
  ifeq ($(shell if test -d $(MODULE_DIR_TST); then echo yes; fi),yes)
   MODULE_DIR := $(MODULE_DIR_TST)/misc
  else
   $(error Unable to find the folder to install the support driver to)
  endif
 endif # MODULE_DIR unspecified
endif

# guess kernel version (24 or 26)
KERN_VERSION := $(if $(wildcard $(KERN_DIR)/Rules.make),24,26)

# debug - show guesses.
ifdef DEBUG
$(warning dbg: KERN_DIR     = $(KERN_DIR))
$(warning dbg: KERN_INCL    = $(KERN_INCL))
$(warning dbg: MODULE_DIR   = $(MODULE_DIR))
$(warning dbg: KERN_VERSION = $(KERN_VERSION))
endif

#
# Compiler options
#
ifndef INCL
 INCL    := -I$(KERN_INCL) $(addprefix -I, $(EXTRA_INCL))
 ifndef KBUILD_EXTMOD
  KBUILD_EXTMOD := $(shell pwd)
 endif
 INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
 export INCL
endif
KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 -DIN_SUP_R0
ifndef CONFIG_VBOXDRV_FIXEDMAJOR
 KFLAGS  += -DCONFIG_VBOXDRV_AS_MISC
endif
ifeq ($(BUILD_TARGET_ARCH),amd64)
 KFLAGS  += -DRT_ARCH_AMD64
else
 KFLAGS  += -DRT_ARCH_X86
endif
#ifeq ($(BUILD_TYPE),debug) - you'll have to enable this manually to get debug stuff.
#KFLAGS   += -DDEBUG
#endif

#
# Use the RTR0MemObj API - testing.
# If this makes testboxes crash/burn/leak disable it and add a comment to defect #2116.
#
KFLAGS += -DUSE_NEW_OS_INTERFACE_FOR_MM
OBJS += r0drv/memobj-r0drv.o \
	r0drv/linux/memobj-r0drv-linux.o
ifeq ($(BUILD_TARGET_ARCH),x86) # Some gcc versions ends up needing __divdi3.
OBJS += math/gcc/qdivrem.o \
	math/gcc/divdi3.o
endif

ifeq ($(KERN_VERSION), 24)
# 2.4
TOPDIR         = $(KERN_DIR)
MODULE_EXT    := o
EXTRA_CFLAGS  := -DVBOX_LINUX_2_4
$(MODULE)-objs = $(OBJS)
else
# 2.6 and later
MODULE_EXT    := ko
$(MODULE)-y   := $(OBJS)
endif

# build defs
EXTRA_CFLAGS  += $(INCL) $(KFLAGS) $(KDEBUG)

all: $(MODULE)

obj-m += $(MODULE).o

$(MODULE):
	$(MAKE) KBUILD_VERBOSE=1 -C $(KERN_DIR) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) modules

ifeq ($(KERN_VERSION), 24)
#
# 2.4 Module linking
#
$(MODULE).o: $(OBJS)
	$(LD) -o $@ -r $(OBJS)

include $(KERN_DIR)/Rules.make

endif

install: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0664 -o root -g root $(MODULE).$(MODULE_EXT) $(MODULE_DIR); \
	PATH="$(PATH):/bin:/sbin" depmod -ae; \
	rm -f /etc/vbox/module_not_compiled

install_rpm: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0664 $(MODULE).$(MODULE_EXT) $(MODULE_DIR)

endif # eq($(MAKECMDGOALS),clean)

clean:
	for f in . linux r0drv r0drv/linux; do rm -f $$f/*.o $$f/.*.cmd $$f/.*.flags; done
	rm -rf .vboxdrv* .tmp_ver* vboxdrv.* Module.symvers Modules.symvers

## virtualbox-ose 1.5.6

=== src/recompiler/tests/Makefile ===
-include ../config-host.mak

CFLAGS=-Wall -O2 -g
#CFLAGS+=-msse2
LDFLAGS=

ifeq ($(ARCH),i386)
TESTS=linux-test testthread sha1-i386 test-i386 runcom
endif
ifeq ($(ARCH),x86_64)
TESTS=test-x86_64
endif
TESTS+=sha1# test_path
#TESTS+=test_path

QEMU=../i386-user/qemu-i386

all: $(TESTS)

hello-i386: hello-i386.c
	$(CC) -nostdlib $(CFLAGS) -static $(LDFLAGS) -o $@ $<
	strip $@

testthread: testthread.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< -lpthread

test_path: test_path.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $<
	./$@ || { rm $@; exit 1; }

# i386/x86_64 emulation test (test various opcodes) */
test-i386: test-i386.c test-i386-code16.S test-i386-vm86.S \
           test-i386.h test-i386-shift.h test-i386-muldiv.h
	$(CC) $(CFLAGS) $(LDFLAGS) -static -o $@ \
              test-i386.c test-i386-code16.S test-i386-vm86.S -lm

test-x86_64: test-i386.c \
           test-i386.h test-i386-shift.h test-i386-muldiv.h
	$(CC) $(CFLAGS) $(LDFLAGS) -static -o $@ test-i386.c -lm

ifeq ($(ARCH),i386)
test: test-i386
	./test-i386 > test-i386.ref
else
test:
endif
	$(QEMU) test-i386 > test-i386.out
	@if diff -u test-i386.ref test-i386.out ; then echo "Auto Test OK"; fi
ifeq ($(ARCH),i386)
	$(QEMU) -no-code-copy test-i386 > test-i386.out
	@if diff -u test-i386.ref test-i386.out ; then echo "Auto Test OK (no code copy)"; fi
endif

# generic Linux and CPU test
linux-test: linux-test.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< -lm

# speed test
sha1-i386: sha1.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $<

sha1: sha1.c
	$(HOST_CC) $(CFLAGS) $(LDFLAGS) -o $@ $<

speed: sha1 sha1-i386
	time ./sha1
	time $(QEMU) ./sha1-i386

# vm86 test
runcom: runcom.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $<

# NOTE: -fomit-frame-pointer is currently needed : this is a bug in libqemu
qruncom: qruncom.c ../i386-user/libqemu.a
	$(CC) $(CFLAGS) -fomit-frame-pointer $(LDFLAGS) -I../target-i386 -I.. -I../i386-user -I../fpu \
              -o $@ $< -L../i386-user -lqemu -lm

# arm test
hello-arm: hello-arm.o
	arm-linux-ld -o $@ $<

hello-arm.o: hello-arm.c
	arm-linux-gcc -Wall -g -O2 -c -o $@ $<

# MIPS test
hello-mips: hello-mips.c
	mips-linux-gnu-gcc -nostdlib -static -mno-abicalls -fno-PIC -mabi=32 -Wall -Wextra -g -O2 -o $@ $<

hello-mipsel: hello-mips.c
	mipsel-linux-gnu-gcc -nostdlib -static -mno-abicalls -fno-PIC -mabi=32 -Wall -Wextra -g -O2 -o $@ $<

# XXX: find a way to compile easily a test for each arch
test2:
	@for arch in i386 arm armeb sparc ppc mips mipsel; do \
           ../$${arch}-user/qemu-$${arch} $${arch}/ls -l linux-test.c ; \
        done

clean:
	rm -f *~ *.o test-i386.out test-i386.ref \
           test-x86_64.log test-x86_64.ref qruncom $(TESTS)

=== src/VBox/HostDrivers/Support/linux/Makefile ===
--- 
+++ 
@@ -40,7 +40,8 @@
 endif
 
 
-MODULE = vboxdrv
+# override is required by the Debian guys
+override MODULE = vboxdrv
 OBJS   = \
 	linux/SUPDrv-linux.o \
 	SUPDRVShared.o \
@@ -58,44 +59,75 @@
 
 ifneq ($(MAKECMDGOALS),clean)
 
-# kernel base directory
-ifndef KERN_DIR
- KERN_DIR := /lib/modules/$(shell uname -r)/build
- ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
-  KERN_DIR := /usr/src/linux
+ifeq ($(KERNELRELEASE),)
+
+ #
+ # building from this directory
+ #
+
+ # kernel base directory
+ ifndef KERN_DIR
+  # build for the current kernel, version check
+  KERN_DIR := /lib/modules/$(shell uname -r)/build
   ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
-   $(error Error: unable to find the sources of your current Linux kernel. Specify KERN_DIR=<directory> and run Make again.)
-  endif
-  $(warning Warning: using /usr/src/linux as the source directory of your Linux kernel. If this is not correct, specify KERN_DIR=<directory> and run Make again.)
- endif
-else
- ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
-  $(error Error: KERN_DIR does not point to a directory.)
- endif
-endif
-
-# includes
-ifndef KERN_INCL
- KERN_INCL = $(KERN_DIR)/include
-endif
-ifneq ($(shell if test -d $(KERN_INCL); then echo yes; fi),yes)
- $(error Error: unable to find the include directory for your current Linux kernel. Specify KERN_INCL=<directory> and run Make again.)
-endif
-
-# module install dir.
-ifneq ($(filter install install_rpm,$(MAKECMDGOALS)),)
- ifndef MODULE_DIR
-  MODULE_DIR_TST := /lib/modules/$(shell uname -r)
-  ifeq ($(shell if test -d $(MODULE_DIR_TST); then echo yes; fi),yes)
-   MODULE_DIR := $(MODULE_DIR_TST)/misc
-  else
-   $(error Unable to find the folder to install the support driver to)
-  endif
- endif # MODULE_DIR unspecified
-endif
-
-# guess kernel version (24 or 26)
-KERN_VERSION := $(if $(wildcard $(KERN_DIR)/Rules.make),24,26)
+   KERN_DIR := /usr/src/linux
+   ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
+    $(error Error: unable to find the sources of your current Linux kernel. \
+	           Specify KERN_DIR=<directory> and run Make again)
+   endif
+   $(warning Warning: using /usr/src/linux as the source directory of your \
+                      Linux kernel. If this is not correct, specify \
+		      KERN_DIR=<directory> and run Make again.)
+  endif
+  # check if versions match -- works only for later 2.6 kernels
+  VBOX_KERN_VER := $(shell $(MAKE) -sC $(KERN_DIR) kernelrelease 2> /dev/null || true)
+  ifneq ($(VBOX_KERN_VER),)
+   ifneq ($(VBOX_KERN_VER),$(shell uname -r))
+    $(error Error: /usr/src/linux (version $(VBOX_KERN_VER)) does not match \
+                   the current kernel (version $(shell uname -r)))
+   endif
+  endif
+ else
+  # build for a dedicated kernel, no version check
+  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
+   $(error Error: KERN_DIR does not point to a directory)
+  endif
+ endif
+
+ # includes
+ ifndef KERN_INCL
+  KERN_INCL = $(KERN_DIR)/include
+ endif
+ ifneq ($(shell if test -d $(KERN_INCL); then echo yes; fi),yes)
+  $(error Error: unable to find the include directory for your current Linux \
+                 kernel. Specify KERN_INCL=<directory> and run Make again)
+ endif
+
+ # module install dir, only for current kernel
+ ifneq ($(filter install install_rpm,$(MAKECMDGOALS)),)
+  ifndef MODULE_DIR
+   MODULE_DIR_TST := /lib/modules/$(shell uname -r)
+   ifeq ($(shell if test -d $(MODULE_DIR_TST); then echo yes; fi),yes)
+    MODULE_DIR := $(MODULE_DIR_TST)/misc
+   else
+    $(error Unable to find the folder to install the support driver to)
+   endif
+  endif # MODULE_DIR unspecified
+ endif
+
+ # guess kernel version (24 or 26)
+ KERN_VERSION := $(if $(wildcard $(KERN_DIR)/Rules.make),24,26)
+
+else # neq($(KERNELRELEASE),)
+
+ #
+ # building from kbuild (make -C <kernel_directory> M=`pwd`)
+ #
+
+ # guess kernel version (24 or 26)
+ KERN_VERSION := $(if $(wildcard $(PWD)/Rules.make),24,26)
+
+endif # neq($(KERNELRELEASE),)
 
 # debug - show guesses.
 ifdef DEBUG
@@ -109,7 +141,7 @@
 # Compiler options
 #
 ifndef INCL
- INCL    := -I$(KERN_INCL) $(addprefix -I, $(EXTRA_INCL))
+ INCL    := $(addprefix -I,$(KERN_INCL) $(EXTRA_INCL))
  ifndef KBUILD_EXTMOD
   KBUILD_EXTMOD := $(shell pwd)
  endif
@@ -128,6 +160,11 @@
 #ifeq ($(BUILD_TYPE),debug) - you'll have to enable this manually to get debug stuff.
 #KFLAGS   += -DDEBUG
 #endif
+
+#
+# Without IDT patching. See defetct #2160.
+#
+KFLAGS += -DVBOX_WITHOUT_IDT_PATCHING
 
 #
 # Use the RTR0MemObj API - testing.

=== src/VBox/Frontends/VirtualBox/src/linux/Makefile ===
# $Id
## @file
# Makefile for building the VirtualBox keyboard handler library.
#

# Note that for reasons of convenience, VirtualBox builds this library
# from inside its own build system rather than using this file.

# Copyright (C) 2008 innotek GmbH
#
# This library is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This library is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# Lesser General Public License as published by the Free Software
# Foundation, in version 2.1 as it comes in the "COPYING.LIB" file of the
# VirtualBox OSE distribution.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
             
VBoxKeyboard.so : keyboard-new.o
	gcc -shared -o VBoxKeyboard.so keyboard-new.o -lX11

## virtualbox-ose 1.6.6

=== src/VBox/HostDrivers/Support/linux/Makefile ===
--- 
+++ 
@@ -5,19 +5,34 @@
 
 #
 #
-#  Copyright (C) 2006 innotek GmbH
-#
-#  This file is part of VirtualBox Open Source Edition (OSE), as
-#  available from http://www.virtualbox.org. This file is free software;
-#  you can redistribute it and/or modify it under the terms of the GNU
-#  General Public License as published by the Free Software Foundation,
-#  in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
-#  distribution. VirtualBox OSE is distributed in the hope that it will
-#  be useful, but WITHOUT ANY WARRANTY of any kind.
-
-#
-# First, figure out which architecture we're targeting.
+# Copyright (C) 2006-2007 Sun Microsystems, Inc.
+#
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+#
+# The contents of this file may alternatively be used under the terms
+# of the Common Development and Distribution License Version 1.0
+# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+# VirtualBox OSE distribution, in which case the provisions of the
+# CDDL are applicable instead of those of the GPL.
+#
+# You may elect to license modified versions of this file under the
+# terms and conditions of either the GPL or the CDDL or both.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
+#
+
+#
+# First, figure out which architecture we're targeting and the build type.
 # (We have to support basic cross building (ARCH=i386|x86_64).)
+# While at it, warn about BUILD_* vars found to help with user problems.
 #
 ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
  $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
@@ -37,6 +52,18 @@
    endif
   endif
  endif
+else
+ $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
+endif
+
+ifneq ($(filter-out release profile debug strict,$(BUILD_TYPE)),)
+ $(warning Ignoring unknown BUILD_TYPE value '$(BUILD_TYPE)'.)
+ BUILD_TYPE :=
+endif
+ifeq ($(BUILD_TYPE),)
+ BUILD_TYPE := release
+else
+ $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
 endif
 
 
@@ -47,14 +74,39 @@
 	SUPDRVShared.o \
 	r0drv/alloc-r0drv.o \
 	r0drv/initterm-r0drv.o \
+	r0drv/linux/mp-r0drv-linux.o \
 	r0drv/linux/alloc-r0drv-linux.o \
 	r0drv/linux/initterm-r0drv-linux.o \
 	r0drv/linux/process-r0drv-linux.o \
-	r0drv/linux/semaphore-r0drv-linux.o \
+	r0drv/linux/semevent-r0drv-linux.o \
+	r0drv/linux/semeventmulti-r0drv-linux.o \
+	r0drv/linux/semfastmutex-r0drv-linux.o \
 	r0drv/linux/spinlock-r0drv-linux.o \
 	r0drv/linux/thread-r0drv-linux.o
 ifeq ($(BUILD_TARGET_ARCH),amd64)
 OBJS  += alloc/heapsimple.o
+endif
+ifeq ($(BUILD_TYPE),debug)
+OBJS  += \
+	math/gcc/divdi3.o \
+	math/gcc/moddi3.o \
+	math/gcc/udivdi3.o \
+	math/gcc/umoddi3.o \
+	math/gcc/qdivrem.o \
+	common/log/log.o \
+	common/log/logcom.o \
+	common/log/logformat.o \
+	common/string/strformat.o \
+	common/string/strformatrt.o \
+	common/string/strformattype.o \
+	common/string/strprintf.o \
+	common/string/strtonum.o \
+	r0drv/linux/RTLogWriteDebugger-r0drv-linux.o \
+	generic/RTLogWriteStdErr-stub-generic.o \
+	generic/RTLogWriteStdOut-stub-generic.o \
+	generic/RTLogWriteUser-generic.o \
+	VBox/log-vbox.o \
+	VBox/strformat-vbox.o
 endif
 
 ifneq ($(MAKECMDGOALS),clean)
@@ -148,7 +200,10 @@
  INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
  export INCL
 endif
-KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 -DIN_SUP_R0
+KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 -DIN_SUP_R0 -DVBOX -DRT_WITH_VBOX
+ifdef VBOX_REDHAT_KABI
+ KFLAGS  += -DVBOX_REDHAT_KABI
+endif
 ifndef CONFIG_VBOXDRV_FIXEDMAJOR
  KFLAGS  += -DCONFIG_VBOXDRV_AS_MISC
 endif
@@ -157,14 +212,11 @@
 else
  KFLAGS  += -DRT_ARCH_X86
 endif
-#ifeq ($(BUILD_TYPE),debug) - you'll have to enable this manually to get debug stuff.
-#KFLAGS   += -DDEBUG
-#endif
-
-#
-# Without IDT patching. See defetct #2160.
-#
-KFLAGS += -DVBOX_WITHOUT_IDT_PATCHING
+ifeq ($(BUILD_TYPE),debug)
+ KFLAGS  += -DDEBUG -DDEBUG_$(USER)
+ # IPRT_DEBUG_SEMS indicates thread wrt sems state via the comm field.
+ KFLAGS  += -DIPRT_DEBUG_SEMS
+endif
 
 #
 # Use the RTR0MemObj API - testing.
@@ -224,5 +276,6 @@
 endif # eq($(MAKECMDGOALS),clean)
 
 clean:
-	for f in . linux r0drv r0drv/linux; do rm -f $$f/*.o $$f/.*.cmd $$f/.*.flags; done
+	for f in . linux r0drv r0drv/linux VBox common/string common/log generic math/gcc; \
+	    do rm -f $$f/*.o $$f/.*.cmd $$f/.*.flags; done
 	rm -rf .vboxdrv* .tmp_ver* vboxdrv.* Module.symvers Modules.symvers

=== src/VBox/Frontends/VirtualBox4/src/linux/Makefile ===
# $Id
## @file
# Makefile for building the VirtualBox keyboard handler library.
#

# Note that for reasons of convenience, VirtualBox builds this library
# from inside its own build system rather than using this file.

# Copyright (C) 2007-2008 Sun Microsystems, Inc.
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#
# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
# Clara, CA 95054 USA or visit http://www.sun.com if you need
# additional information or have any questions.
#

VBoxKeyboard.so : keyboard-new.o
	gcc -shared -o VBoxKeyboard.so keyboard-new.o -lX11

## virtualbox-ose 2.0.4-dfsg-0ubuntu1

=== debian/virtualbox-ose-guest-source.files/Makefile ===
obj-m = vboxadd/ vboxvfs/

=== debian/changelog ===
virtualbox-ose (2.0.4-dfsg-0ubuntu1) intrepid; urgency=low

  [ Jonathan Ernst ]
  * Virtualbox should go in Accessories, not in System tools (LP: #288590) 

  [ Daniel Hahler ]
  * New upstream version (LP: #288957)
    - Updated debian/patches/09-initscript.dpatch (one hunk rejected/obsolete)
  * Drop debconf question about losing snapshots because of upgrading: it is
    no longer relevant and the default (cancel upgrade) caused a lot of
    trouble (LP: #288178, #221736)
    - debian/virtualbox-ose.preinst.in, debian/virtualbox-ose.templates,
      debian/rules
  * Improve patch for disabling the "check for updates" dialog (LP: #272212)
    - debian/patches/13-disable-update-action.dpatch
  * Disable registration request at Sun (LP: #285684, #271603)
    - debian/patches/14-disable-registration-request.dpatch

 -- Daniel Hahler <ubuntu@thequod.de>  Sun, 26 Oct 2008 02:23:42 +0100

virtualbox-ose (2.0.2-dfsg-0ubuntu3) intrepid; urgency=low

  * debian/patches/13-disable-update-action.dpatch:
    Disable update action menu entry (LP: #272212)

 -- Daniel Hahler <ubuntu@thequod.de>  Fri, 19 Sep 2008 23:33:32 +0200

virtualbox-ose (2.0.2-dfsg-0ubuntu2) intrepid; urgency=low

  * debian/virtualbox-ose.install:
    - Install VBoxHeadless (LP: #271753)
  * debian/virtualbox-ose.links:
    - Include symlink for VBoxHeadless
  * debian/virtualbox-ose.files/VBox.sh:
    - Remove check for vboxusers, not necessary w/
      hardening.
  * debian/virtualbox-ose.udev:
    - Don't set vboxdrv to vboxusers, not necessary
      w/ hardening.
  * debian/virtualbox-ose.vboxdrv.init:
    - Remove permissions check for vboxdrv.
  * debian/rules:
    - Enable 64 bit guest support when building on 
      AMD64 (LP: #271651)
    - Set VBoxHeadless suid.
  * debian/control:
    - Add depends for linux-headers to make sure
      that the modules can compile initially (LP: #271534)

 -- Mario Limonciello <mario_limonciello@dell.com>  Thu, 18 Sep 2008 12:49:02 -0500

virtualbox-ose (2.0.2-dfsg-0ubuntu1) intrepid; urgency=low

  * New upstream version (LP: #268795)
    - Introduces support for Intrepid Guests
    - Introduces support for kernel 2.6.27
  * Update patches for new upstream version:
    - 02-config-kmk
    - 09-initscript
  * Drop patches no longer necessary (or absorbed upstream):
    - 05-vboxadd-udev
    - 01-no-64bit-guest
  * New patches:
    - 01-64bit, for making sure we query the target arch properly.
  * debian/control:
    - Build depend on libqt4-dev for new upstream version.
    - Build depend on python2.5-dev for new upstream version.
    - Drop libqt3-mt-dev from build depends
    - Bump provides of guest-utils to xserver-xorg-input-2.1
    - Bump provides of guest-utils to xserver-xorg-video-2.9
    - Enable 64 bit guest utils support.
  * debian/rules:
    - Disable QT3 support as we are using the QT4 frontend by
      default.
    - Set VirtualBox binaries to suid root per new hardening
      requirements in this release.
    - Add amd64 to a valid arch in the X11 additions check.
  * debian/virtualbox-ose.install:
    - Update location that xpidl is installed from.
  * debian/virtualbox-ose.vboxdrv.init:
    - Start at runlevels 2,3,4,5 rather than just 3,5
  * Enable DKMS support on virtualbox host and guest modules. (LP: #267097)
    - Rebuilding is no longer necessary for new kernels (LP: #268367)
    - Drop:
      + virtualbox-ose-source.files/rules
      + virtualbox-ose-source.files/postinst.modules.in
      + virtualbox-ose-source.files/control.modules.in
      + virtualbox-ose-guest-source.files/rules
      + virtualbox-ose-guest-source.files/postinst.modules.in
      + virtualbox-ose-guest-source.files/control.modules.in
      + virtualbox-ose-source.links
    - Rename / Add version to .in files:
      + virtualbox-ose-guest-source.files/udev -> 
        virtualbox-ose-guest-source.udev
      + virtualbox-ose-guest-source.install -> 
        virtualbox-ose-guest-source.install.in
      + virtualbox-ose-source.dirs -> virtualbox-ose-source.dirs.in
      + virtualbox-ose-guest-source.dirs -> virtualbox-ose-guest-source.dirs.in
      + virtualbox-ose-guest-source.links -> 
        virtualbox-ose-guest-source.links.in
    - New:
      + virtualbox-ose-source.files/dkms.conf.in
      + virtualbox-ose-source.postinst
      + virtualbox-ose-source.prerm
      + virtualbox-ose-guest-source.prerm
      + virtualbox-ose-guest-source.postinst
      + virtualbox-ose-guest-source.files/dkms.conf.in
      + virtualbox-ose-guest-source.files/Makefile
    - debian/rules:
      + Add support to update all ".in" files in install target
      + Add support to remove all sed produced ".in" files in clean target
      + Drop extra rules that were modifying the "debian" directory in -source.
      + Make sure to include postinst/prerm scripts for arch indep packages.
    - debian/control:
      + Recommends on the source package instead of modules packages
      + Depends on the source packages for dkms and libc6-dev
    - debian/virtualbox-ose.vboxdrv.init:
      + Search for module in proper location

 -- Mario Limonciello <mario_limonciello@dell.com>  Wed, 10 Sep 2008 13:50:20 -0500

virtualbox-ose (1.6.2-dfsg-1ubuntu2) intrepid; urgency=low

  * Fix dpatch 01-no-64bit-guest to change upstream's uname -m into
    dpkg-architecture -qDEB_HOST_GNU_CPU instead of dpkg --print-architecture;
    fixes build on lpia.
  * Build virtualbox-ose, virtualbox-ose-dbg, and virtualbox-ose-guest-utils
    for lpia.
  * Set VBOX_WITH_X11_ADDITIONS in rules when the DEB_HOST_ARCH is i386 or
    lpia instead of using dpkg --print-architecture.
  * Use the -s flag to dh_ commands instead of 3 debhelper calls and a shell
    test; as a bonus, this provides additional detached symbols in -dbg.
  * Install files into virtualbox-ose-guest-utils unconditionally and ignore
    errors -- even if these exist, the package is disabled on amd64.
  * Cleanup upstreamversion computation and compute it only once.


=== debian/control ===
Source: virtualbox-ose
Section: misc
Priority: extra
Maintainer: Ubuntu MOTU Developers <ubuntu-motu@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Virtualbox Team <pkg-virtualbox-devel@lists.alioth.debian.org>
Uploaders: Philipp Hug <debian@hug.cx>, Marvin Stark <marv@der-marv.de>, Michael Meskes <meskes@debian.org>, Patrick Winnertz <winnie@debian.org>, Daniel Baumann <daniel@debian.org>, Hilko Bengen <bengen@debian.org>
Build-Depends: debhelper (>= 5.0.44~), dpatch, bcc, bzip2, g++-4.2-multilib [amd64], iasl, kbuild, libacl1-dev, libasound-dev, libhal-dev, libidl-dev, libsdl1.2-dev, libxslt1-dev, uuid-dev, yasm (>= 0.7.0), libpulse-dev, po-debconf (>= 0.5.0), docbook-xsl, xsltproc, lynx, docbook-xml, gcc-4.2, g++-4.2, libqt4-dev, python2.5-dev
Standards-Version: 3.8.0
Homepage: http://www.virtualbox.org/
XS-Original-Vcs-Svn: svn://svn.debian.org/svn/pkg-virtualbox/trunk
XS-Original-Vcs-Browser: http://svn.debian.org/wsvn/pkg-virtualbox/trunk

Package: virtualbox-ose
Architecture: amd64 i386 lpia
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Pre-Depends: debconf | debconf-2.0
Recommends: virtualbox-ose-source
Suggests: bridge-utils
Conflicts: virtualbox
Replaces: virtualbox
Provides: virtualbox
Description: x86 virtualization solution - binaries
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the binaries for the Open Source Edition of
 VirtualBox. The virtualbox-ose-source package is also required in order to
 compile the kernel modules needed for virtualbox-ose.

Package: virtualbox-ose-dbg
Section: devel
Priority: extra
Architecture: amd64 i386 lpia
Depends: virtualbox-ose (= ${binary:Version})
Description: x86 virtualization solution - debugging symbols
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the debugging symbols for the Open Source Edition of
 VirtualBox.

Package: virtualbox-ose-source
Architecture: all
Depends: dkms, libc6-dev, linux-headers-generic | linux-headers
Conflicts: virtualbox-source
Replaces: virtualbox-source
Provides: virtualbox-source
Description: x86 virtualization solution - kernel module source
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox kernel module.
 The virtualbox-ose package is also required in order to make use of these
 modules. Kernel sources or headers are required to compile this module.

Package: virtualbox-ose-guest-source
Architecture: all
Depends: dkms, libc6-dev, linux-headers-generic | linux-headers
Description: x86 virtualization solution - guest addition module source
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox guest addition kernel
 modules. The virtualbox-ose-guest-utils package is also required in order to
 make use of these modules. Kernel sources or headers are required to compile
 these modules.

Package: virtualbox-ose-guest-utils
Architecture: i386 lpia amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, pciutils
Conflicts: xserver-xorg-core (< 2:1.4)
Recommends: virtualbox-ose-guest-modules, xserver-xorg-core (>= 2:1.4)
Suggests: virtualbox-ose-guest-source
Provides: xserver-xorg-video-2.9, xserver-xorg-input-2.1
Description: x86 virtualization solution - guest utilities
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the guest utilities of the Open Source Edition of
 VirtualBox. These utilities are meant to be run inside the virtual machine.
 They provide closer integration (e.g. mouse pointer, time synchronization),
 improve the interactive performance (e.g. better video support), and allow to
 share data through shared folders between the host system and the virtual
 machine.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpatch/dpatch.make

# some default definitions, important!
#
# Name of the source packages
psource:=virtualbox-ose-source
gsource:=virtualbox-ose-guest-source

# The short upstream name
sname:=virtualbox-ose
gname:=virtualbox-ose-guest
uname:=virtualbox-ose-guest-utils

MAKE:=kmk

upstreamversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

VBOX_WITH_X11_ADDITIONS :=
ifeq ($(filter-out amd64 i386 lpia,$(DEB_HOST_ARCH)),)
VBOX_WITH_X11_ADDITIONS := 1
endif

VBOX_WITH_64_BITS_GUESTS :=
ifeq ($(filter-out amd64,$(DEB_HOST_ARCH)),)
VBOX_WITH_64_BITS_GUESTS := 1
endif

# Generate README.Debian as text/html ...
debian/README.Debian.html: debian/virtualbox-ose.README.Debian.xml
	xsltproc --nonet --stringparam section.autolabel 1 \
	-o $@ \
	/usr/share/xml/docbook/stylesheet/nwalsh/html/docbook.xsl \
	$<

# ... and text/plain
debian/virtualbox-ose.README.Debian: debian/README.Debian.html
	chmod 755 debian/lynx-dump-postprocess
	(LANG=C; lynx -force_html -dump $< | ./debian/lynx-dump-postprocess > $@.tmp)
	mv $@.tmp $@

env.sh: patch-stamp
	dh_testdir
	./configure --with-linux="/usr" --disable-kmods --with-gcc=/usr/bin/gcc-4.2 --with-g++=/usr/bin/g++-4.2 --disable-qt3
ifeq ($(VBOX_WITH_X11_ADDITIONS),)
	echo "VBOX_WITH_X11_ADDITIONS=" >> LocalConfig.kmk
else
	echo "VBOX_WITH_X11_ADDITIONS=1" >> LocalConfig.kmk
endif

ifeq ($(VBOX_WITH_64_BITS_GUESTS),)
	echo "VBOX_WITH_64_BITS_GUESTS=" >> LocalConfig.kmk
else
	echo "VBOX_WITH_64_BITS_GUESTS=1" >> LocalConfig.kmk
endif

build: build-stamp
build-stamp: env.sh
	dh_testdir

	# Building package
	$(MAKE) \
		BUILD_TYPE=release \
		PATH_OUT=$(abspath out)
	# make sure VBoxAddIF.sh is built, too
	$(MAKE) -C src/VBox/Installer/linux $(abspath out/bin/VBoxAddIF.sh) \
		PATH_OUT=$(abspath out)
	# and vboxnet.sh
	$(MAKE) -C src/VBox/Installer/linux $(abspath out/obj/src/VBox/Installer/linux/vboxnet.sh) \
		PATH_OUT=$(abspath out)

	touch build-stamp

clean: unpatch
	dh_testdir
	dh_testroot

	# Cleaning package
	rm -rf out
	rm -f AutoConfig.kmk configure.log env.sh
	rm -f debian/$(sname).init debian/$(sname).preinst
	rm -f debian/virtualbox-ose.README.Debian debian/README.Debian.html
	rm -f debian/{$(psource),$(gsource)}.files/dkms.conf
	rm -f debian/{$(psource),$(gsource)}.{install,dirs}
	rm -f debian/$(gsource).links

	dh_clean

#Rebuild the orig.tar.gz
dfsg-free: clean
	rm -rf ./kBuild
	rm -rf ./tools
	rm -rf ./src/VBox/Additions/os2
	rm -rf ./src/VBox/Additions/WINNT
	rm -f ./src/VBox/HostDrivers/VBoxTAP/VBoxTAP.rc
	rm -f ./src/VBox/HostDrivers/Support/darwin/load.sh
	rm -f ./include/VBox/VBoxGuest.inc
	rm -f ./include/VBox/VBoxGuest16.h
	rm -f ./include/VBox/VBoxGuest.mac
	rm -f ./src/libs/xpcom18a4/xpcom/MoreFiles/FSCopyObject.c
	rm -f ./src/libs/xpcom18a4/xpcom/MoreFiles/FSCopyObject.h
	rm -rf ./src/libs/ffmpeg-20060710
	rm -rf ./src/libs/libpng*
	rm -rf ./src/libs/libxml2*
	rm -rf ./src/libs/libxslt*
	rm -rf ./src/libs/zlib*
	rm -f ./src/VBox/HostServices/SharedClipboard/linux-stub.cpp
	rm -f ./src/VBox/Additions/linux/xmouse/Imakefile
	rm -rf ./src/VBox/Additions/linux/selinux-fedora

	(cd ..; mv $(CURDIR) virtualbox-ose-$(upstreamversion)-dfsg; \
	 tar --exclude .svn --exclude '.git*' --exclude debian \
		-czf virtualbox-ose_$(upstreamversion)-dfsg.orig.tar.gz \
		virtualbox-ose-$(upstreamversion)-dfsg)

# install: DH_OPTIONS=
install: build debian/virtualbox-ose.README.Debian debian/README.Debian.html
	dh_testdir
	dh_testroot
	dh_clean -k

	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(gsource).dirs.in > debian/$(gsource).dirs
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(psource).dirs.in > debian/$(psource).dirs
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(gsource).links.in > debian/$(gsource).links

	dh_installdirs

	# This will get installed into the package by dh_installinit
	install -m 644 out/obj/src/VBox/Installer/linux/vboxnet.sh debian/$(sname).init

	# We also need to build a preinst file
	sed -e 's/UPSTREAM/"$(upstreamversion)"/' < debian/$(sname).preinst.in > debian/$(sname).preinst

	# Create DKMS control files
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(psource).files/dkms.conf.in > debian/$(psource).files/dkms.conf
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(gsource).files/dkms.conf.in > debian/$(gsource).files/dkms.conf

	#Build install files for the dkms'ified sources
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(psource).install.in > debian/$(psource).install
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(gsource).install.in > debian/$(gsource).install

	# Install helper scripts for vbox* interfaces
	dh_installifupdown -p${sname}

binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installmenu -a
	dh_install -s
	chmod 755 debian/$(sname)/usr/share/virtualbox/VBox.sh;
	-chmod 755 debian/$(uname)/usr/share/virtualbox/x11config.pl
	-install -m 644 out/bin/additions/vboxvideo_drv_14.so debian/$(uname)/usr/lib/xorg/modules/drivers/vboxvideo_drv.so
	-install -m 644 out/bin/additions/vboxmouse_drv_14.so debian/$(uname)/usr/lib/xorg/modules/input/vboxmouse_drv.so
	-install -m 755 out/bin/additions/mountvboxsf debian/$(uname)/sbin/mount.vboxsf
	dh_strip -s --dbg-package=$(sname)-dbg -X/usr/share/virtualbox/sdk/bin/xpidl
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	#version 2.0.2 introduces hardening. these binaries will ONLY run suid root.
	chmod +s debian/$(sname)/usr/lib/virtualbox/VirtualBox
	chmod +s debian/$(sname)/usr/lib/virtualbox/VBoxSDL
	chmod +s debian/$(sname)/usr/lib/virtualbox/VBoxBFE
	chmod +s debian/$(sname)/usr/lib/virtualbox/VBoxHeadless
	dh_installudev -a
	dh_installdebconf -a
	dh_installinit -a
	dh_installinit --name=vboxdrv -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -s
	dh_md5sums -a
	dh_builddeb -s

binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i
	dh_installdocs -i
	dh_install -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary: binary-arch binary-indep
.PHONY: patch unpatch \
	build clean binary-arch binary-indep binary install \
	binary-modules kdist kdist_configure kdist_image kdist_clean

## virtualbox-ose 2.1.4

=== src/VBox/Additions/linux/Makefile ===
#
# Makefile for the VirtualBox Linux Guest Drivers.
#

#
#
# Copyright (C) 2009 Sun Microsystems, Inc.
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#
# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
# Clara, CA 95054 USA or visit http://www.sun.com if you need
# additional information or have any questions.
#

KBUILD_VERBOSE =

all:
	@echo "*** Building 'vboxadd' module ***"
	@$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxadd
	@cp vboxadd/vboxadd.ko .
	@echo
	@if [ -d vboxvfs ]; then \
	    if [ -f vboxadd/Module.symvers ]; then \
	        cp vboxadd/Module.symvers vboxvfs; \
	    fi; \
	    echo "*** Building 'vboxvfs' module ***"; \
	    $(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxvfs; \
	    cp vboxvfs/vboxvfs.ko .; \
	fi


install:
	@$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxadd install
	@if [ -d vboxvfs ]; then \
	    $(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxvfs install; \
	fi

clean:
	@$(MAKE) -C vboxadd clean
	@if [ -d vboxvfs ]; then \
	    $(MAKE) -C vboxvfs clean; \
	fi
	rm -f vboxadd.ko vboxvfs.ko

load:
	@/sbin/rmmod vboxvfs || true
	@/sbin/rmmod vboxadd || true
	@/sbin/insmod vboxadd.ko
	@if [ -f vboxvfs.ko ]; then /sbin/insmod vboxvfs.ko; fi

=== src/VBox/HostDrivers/linux/Makefile ===
#
# Makefile for the VirtualBox Linux Host Drivers.
#

#
#
# Copyright (C) 2008-2009 Sun Microsystems, Inc.
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#
# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
# Clara, CA 95054 USA or visit http://www.sun.com if you need
# additional information or have any questions.
#

KBUILD_VERBOSE =

all:
	@echo "*** Building 'vboxdrv' module ***"
	@$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxdrv
	@cp vboxdrv/vboxdrv.ko .
	@echo
	@if [ -d vboxnetflt ]; then \
	    if [ -f vboxdrv/Module.symvers ]; then \
	        cp vboxdrv/Module.symvers vboxnetflt; \
	    fi; \
	    echo "*** Building 'vboxnetflt' module ***"; \
	    $(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxnetflt; \
	    cp vboxnetflt/vboxnetflt.ko .; \
	fi


install:
	@$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxdrv install
	@if [ -d vboxnetflt ]; then \
	    $(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C vboxnetflt install; \
	fi

clean:
	@$(MAKE) -C vboxdrv clean
	@if [ -d vboxnetflt ]; then \
	    $(MAKE) -C vboxnetflt clean; \
	fi
	rm -f vboxdrv.ko vboxnetflt.ko

load:
	@for module in vboxnetflt vboxdrv; do \
		if grep "^$$module " /proc/modules >/dev/null; then \
			echo "Removing previously installed $$module module"; \
			/sbin/rmmod $$module; \
		fi; \
	done
	@for module in vboxdrv vboxnetflt; do \
		if test -f $$module.ko; then \
			echo "Installing $$module module"; \
			/sbin/insmod $$module.ko; \
		fi; \
	done

=== src/VBox/HostDrivers/Support/linux/Makefile ===
--- 
+++ 
@@ -66,34 +66,39 @@
  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
 endif
 
+# use vm_insert_page() API (if available) to map kernel pages to userland - better debugging 
+# VBOX_USE_INSERT_PAGE = 1
 
 # override is required by the Debian guys
 override MODULE = vboxdrv
 OBJS   = \
 	linux/SUPDrv-linux.o \
-	SUPDRVShared.o \
+	SUPDrv.o \
 	r0drv/alloc-r0drv.o \
 	r0drv/initterm-r0drv.o \
-	r0drv/linux/mp-r0drv-linux.o \
+	r0drv/memobj-r0drv.o \
+	r0drv/mpnotification-r0drv.o \
+	r0drv/powernotification-r0drv.o \
+	r0drv/linux/assert-r0drv-linux.o \
 	r0drv/linux/alloc-r0drv-linux.o \
 	r0drv/linux/initterm-r0drv-linux.o \
+	r0drv/linux/memobj-r0drv-linux.o \
+	r0drv/linux/mp-r0drv-linux.o \
+	r0drv/linux/mpnotification-r0drv-linux.o \
 	r0drv/linux/process-r0drv-linux.o \
 	r0drv/linux/semevent-r0drv-linux.o \
 	r0drv/linux/semeventmulti-r0drv-linux.o \
 	r0drv/linux/semfastmutex-r0drv-linux.o \
 	r0drv/linux/spinlock-r0drv-linux.o \
-	r0drv/linux/thread-r0drv-linux.o
-ifeq ($(BUILD_TARGET_ARCH),amd64)
-OBJS  += alloc/heapsimple.o
-endif
-ifeq ($(BUILD_TYPE),debug)
-OBJS  += \
-	math/gcc/divdi3.o \
-	math/gcc/moddi3.o \
-	math/gcc/udivdi3.o \
-	math/gcc/umoddi3.o \
-	math/gcc/qdivrem.o \
+	r0drv/linux/thread-r0drv-linux.o \
+	r0drv/linux/thread2-r0drv-linux.o \
+	r0drv/linux/time-r0drv-linux.o \
+	r0drv/linux/timer-r0drv-linux.o \
+	common/err/RTErrConvertFromErrno.o \
 	common/log/log.o \
+	common/log/logellipsis.o \
+	common/log/logrel.o \
+	common/log/logrelellipsis.o \
 	common/log/logcom.o \
 	common/log/logformat.o \
 	common/string/strformat.o \
@@ -102,11 +107,22 @@
 	common/string/strprintf.o \
 	common/string/strtonum.o \
 	r0drv/linux/RTLogWriteDebugger-r0drv-linux.o \
+	generic/RTAssertShouldPanic-generic.o \
 	generic/RTLogWriteStdErr-stub-generic.o \
 	generic/RTLogWriteStdOut-stub-generic.o \
 	generic/RTLogWriteUser-generic.o \
 	VBox/log-vbox.o \
 	VBox/strformat-vbox.o
+ifeq ($(BUILD_TARGET_ARCH),x86)
+OBJS += math/gcc/divdi3.o \
+	math/gcc/moddi3.o \
+	math/gcc/qdivrem.o \
+	math/gcc/udivdi3.o \
+        math/gcc/divdi3.o \
+	math/gcc/umoddi3.o
+endif
+ifeq ($(BUILD_TARGET_ARCH),amd64)
+OBJS += alloc/heapsimple.o
 endif
 
 ifneq ($(MAKECMDGOALS),clean)
@@ -189,6 +205,8 @@
 $(warning dbg: KERN_VERSION = $(KERN_VERSION))
 endif
 
+KBUILD_VERBOSE ?= 1
+
 #
 # Compiler options
 #
@@ -200,7 +218,7 @@
  INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
  export INCL
 endif
-KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 -DIN_SUP_R0 -DVBOX -DRT_WITH_VBOX
+KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 -DIN_SUP_R0 -DVBOX -DRT_WITH_VBOX -DVBOX_WITH_HARDENING
 ifdef VBOX_REDHAT_KABI
  KFLAGS  += -DVBOX_REDHAT_KABI
 endif
@@ -212,35 +230,29 @@
 else
  KFLAGS  += -DRT_ARCH_X86
 endif
+# must be consistent with Config.kmk!
+KFLAGS  += -DVBOX_WITH_64_BITS_GUESTS
 ifeq ($(BUILD_TYPE),debug)
- KFLAGS  += -DDEBUG -DDEBUG_$(USER)
+ KFLAGS  += -DDEBUG -DDEBUG_$(USER) -g
  # IPRT_DEBUG_SEMS indicates thread wrt sems state via the comm field.
  KFLAGS  += -DIPRT_DEBUG_SEMS
 endif
 
-#
-# Use the RTR0MemObj API - testing.
-# If this makes testboxes crash/burn/leak disable it and add a comment to defect #2116.
-#
-KFLAGS += -DUSE_NEW_OS_INTERFACE_FOR_MM
-OBJS += r0drv/memobj-r0drv.o \
-	r0drv/linux/memobj-r0drv-linux.o
-ifeq ($(BUILD_TARGET_ARCH),x86) # Some gcc versions ends up needing __divdi3.
-OBJS += math/gcc/qdivrem.o \
-	math/gcc/divdi3.o
-endif
-
-ifeq ($(KERN_VERSION), 24)
-# 2.4
-TOPDIR         = $(KERN_DIR)
-MODULE_EXT    := o
-EXTRA_CFLAGS  := -DVBOX_LINUX_2_4
-$(MODULE)-objs = $(OBJS)
-else
+# By default we use remap_pfn_range() kernel API to make kernel pages
+# visible for userland. Unfortuately, it leads to situation that
+# during debug session all structures on that page (such as PVM pointer)
+# are not accessible to the debugger (see #3214).
+# This code enables experimental support
+# for vm_insert_page() kernel API, allowing to export kernel pages
+# to the userland in more debugger-friendly way. Due to stability
+# concerns, not enabled by default yet.
+ifdef VBOX_USE_INSERT_PAGE
+ KFLAGS  += -DVBOX_USE_INSERT_PAGE
+endif
+
 # 2.6 and later
 MODULE_EXT    := ko
 $(MODULE)-y   := $(OBJS)
-endif
 
 # build defs
 EXTRA_CFLAGS  += $(INCL) $(KFLAGS) $(KDEBUG)
@@ -250,18 +262,7 @@
 obj-m += $(MODULE).o
 
 $(MODULE):
-	$(MAKE) KBUILD_VERBOSE=1 -C $(KERN_DIR) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) modules
-
-ifeq ($(KERN_VERSION), 24)
-#
-# 2.4 Module linking
-#
-$(MODULE).o: $(OBJS)
-	$(LD) -o $@ -r $(OBJS)
-
-include $(KERN_DIR)/Rules.make
-
-endif
+	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) -C $(KERN_DIR) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) modules
 
 install: $(MODULE)
 	@mkdir -p $(MODULE_DIR); \
@@ -276,6 +277,6 @@
 endif # eq($(MAKECMDGOALS),clean)
 
 clean:
-	for f in . linux r0drv r0drv/linux VBox common/string common/log generic math/gcc; \
+	for f in . linux r0drv r0drv/linux VBox common/err common/string common/log generic math/gcc; \
 	    do rm -f $$f/*.o $$f/.*.cmd $$f/.*.flags; done
-	rm -rf .vboxdrv* .tmp_ver* vboxdrv.* Module.symvers Modules.symvers
+	rm -rf .vboxdrv* .tmp_ver* vboxdrv.* Module.symvers Modules.symvers modules.order

=== src/VBox/Main/webservice/samples/python/Makefile ===
#
# Copyright (C) 2008 Sun Microsystems, Inc.
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#
# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
# Clara, CA 95054 USA or visit http://www.sun.com if you need
# additional information or have any questions.
#

all: run

run: 
	PYTHONPATH=../lib python ./clienttest.py
